<?php

final class Kintone_Options
{
	const sub_domain	  = 'kintone-sub_domain';
	const api_token	   = 'kintone-api_token';
	const basic_auth_user = 'kintone-basic_auth_user';
	const basic_auth_pass = 'kintone-basic_auth_pass';

	/*
	 * constructor
	 */
	private function __construct()
	{

	}

	/*
	 * get instance
	 */
	public static function getInstance()
	{
		/**
		* a variable that keeps the sole instance.
		*/
		static $instance;

		if (!isset($instance)) {
			$instance = new Kintone_API();
		}
		return $instance;
	}

	/*
	 * don't allow you to clone the instance.
	 */
	public final function __clone() {
		throw new RuntimeException('Clone is not allowed against ');
	}

	public static function get_sub_domain()
	{
		return self::get(self::sub_domain);
	}

	public static function update_sub_domain($value)
	{
		return self::update(self::sub_domain, $value);
	}

	// public static function get_api_token()
	// {
	//	 return self::get(self::api_token);
	// }
	//
	// public static function update_api_token($value)
	// {
	//	 return self::update(self::api_token, $value);
	// }

	public static function get_basic_auth_user()
	{
		return self::get(self::basic_auth_user);
	}

	public static function update_basic_auth_user($value)
	{
		return self::update(self::basic_auth_user, $value);
	}

	public static function get_basic_auth_pass()
	{
		return self::get(self::basic_auth_pass);
	}

	public static function update_basic_auth_pass($value)
	{
		return self::update(self::basic_auth_pass, $value);
	}

	protected static function get($key, $default = null)
	{
		return get_option($key, $default);
	}

	protected static function update($key, $value)
	{
		update_option($key, trim(stripslashes($value)));
	}
}


// EOF
